From 4cca929d18b57ee9c34cded220ec97a52938523c Mon Sep 17 00:00:00 2001
From: Shogo Matsumoto <shogo.matsumoto@fujitsu.com>
Date: Tue, 26 Nov 2019 18:22:25 -0500
Subject: [PATCH] -n option of dbverify does not work

Correct a field name in order to pass instance names
specified by -n to backend's dbverify function.
---
 ldap/servers/slapd/main.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/ldap/servers/slapd/main.c b/ldap/servers/slapd/main.c
index bebd3cf72..8723fd15e 100644
--- a/ldap/servers/slapd/main.c
+++ b/ldap/servers/slapd/main.c
@@ -2620,7 +2620,7 @@ slapd_exemode_dbverify(struct main_config *mcfg)
     slapi_pblock_set(pb, SLAPI_BACKEND, NULL);
     slapi_pblock_set(pb, SLAPI_PLUGIN, backend_plugin);
     slapi_pblock_set(pb, SLAPI_SEQ_TYPE, &(mcfg->dbverify_verbose));
-    slapi_pblock_set(pb, SLAPI_BACKEND_INSTANCE_NAME, mcfg->cmd_line_instance_name);
+    slapi_pblock_set(pb, SLAPI_BACKEND_INSTANCE_NAME, mcfg->cmd_line_instance_names);
     int32_t task_flags = SLAPI_TASK_RUNNING_FROM_COMMANDLINE;
     slapi_pblock_set(pb, SLAPI_TASK_FLAGS, &task_flags);
     slapi_pblock_set(pb, SLAPI_DBVERIFY_DBDIR, mcfg->dbverify_dbdir);
-- 
2.23.0