From c9996730ff7e3847e1d481a296c384afbd7ffdad Mon Sep 17 00:00:00 2001
From: Carsten Grzemba <cgrzemba@opencsw.org>
Date: Fri, 6 Oct 2017 15:28:21 +0200
Subject: [PATCH 3/3] add hardware threads determination for Solaris

---
 ldap/servers/slapd/util.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/ldap/servers/slapd/util.c b/ldap/servers/slapd/util.c
index a0f3268da..043bc2083 100644
--- a/ldap/servers/slapd/util.c
+++ b/ldap/servers/slapd/util.c
@@ -1491,7 +1491,7 @@ util_is_cachesize_sane(slapi_pal_meminfo *mi, uint64_t *cachesize)
 long
 util_get_hardware_threads(void)
 {
-#ifdef LINUX
+#if defined(LINUX) || defined(SOLARIS)
     long hw_threads = sysconf(_SC_NPROCESSORS_ONLN);
     long threads = 0;
     slapi_log_err(SLAPI_LOG_TRACE, "util_get_hardware_threads", "Detected %lu hardware threads\n", threads);
-- 
2.13.5